/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.faziz.flexigrid.domain;

import java.io.Serializable;
import java.util.Collection;
import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author faisal
 */
@Entity
@Table(name = "line_item")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "LineItem.findAll", query = "SELECT l FROM LineItem l"),
    @NamedQuery(name = "LineItem.findById", query = "SELECT l FROM LineItem l WHERE l.id = :id"),
    @NamedQuery(name = "LineItem.findByUnitPrice", query = "SELECT l FROM LineItem l WHERE l.unitPrice = :unitPrice"),
    @NamedQuery(name = "LineItem.findByUnits", query = "SELECT l FROM LineItem l WHERE l.units = :units")})
public class LineItem implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @NotNull
    @Column(name = "ID")
    private Integer id;
    @Basic(optional = false)
    @NotNull
    @Column(name = "UNIT_PRICE")
    private double unitPrice;
    @Basic(optional = false)
    @NotNull
    @Column(name = "UNITS")
    private int units;
    @JoinTable(name = "purchase_order_line_item", joinColumns = {
        @JoinColumn(name = "LINE_ITEM_ID", referencedColumnName = "ID")}, inverseJoinColumns = {
        @JoinColumn(name = "PURCHASE_ORDER_ID", referencedColumnName = "ID")})
    @ManyToMany
    private Collection<PurchaseOrder> purchaseOrderCollection;
    @JoinTable(name = "sale_order_line_item", joinColumns = {
        @JoinColumn(name = "LINE_ITEM_ID", referencedColumnName = "ID")}, inverseJoinColumns = {
        @JoinColumn(name = "SALE_ORDER_ID", referencedColumnName = "ID")})
    @ManyToMany
    private Collection<SaleOrder> saleOrderCollection;
    @JoinColumn(name = "MEDICINE_ID", referencedColumnName = "ID")
    @ManyToOne(optional = false)
    private Medicine medicineId;

    public LineItem() {
    }

    public LineItem(Integer id) {
        this.id = id;
    }

    public LineItem(Integer id, double unitPrice, int units) {
        this.id = id;
        this.unitPrice = unitPrice;
        this.units = units;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public double getUnitPrice() {
        return unitPrice;
    }

    public void setUnitPrice(double unitPrice) {
        this.unitPrice = unitPrice;
    }

    public int getUnits() {
        return units;
    }

    public void setUnits(int units) {
        this.units = units;
    }

    @XmlTransient
    public Collection<PurchaseOrder> getPurchaseOrderCollection() {
        return purchaseOrderCollection;
    }

    public void setPurchaseOrderCollection(Collection<PurchaseOrder> purchaseOrderCollection) {
        this.purchaseOrderCollection = purchaseOrderCollection;
    }

    @XmlTransient
    public Collection<SaleOrder> getSaleOrderCollection() {
        return saleOrderCollection;
    }

    public void setSaleOrderCollection(Collection<SaleOrder> saleOrderCollection) {
        this.saleOrderCollection = saleOrderCollection;
    }

    public Medicine getMedicineId() {
        return medicineId;
    }

    public void setMedicineId(Medicine medicineId) {
        this.medicineId = medicineId;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof LineItem)) {
            return false;
        }
        LineItem other = (LineItem) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "org.faziz.flexigrid.domain.LineItem[ id=" + id + " ]";
    }
    
}
