/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.faziz.flexigrid.domain;

import java.io.Serializable;
import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author faisal
 */
@Entity
@Table(name = "store")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Store.findAll", query = "SELECT s FROM Store s"),
    @NamedQuery(name = "Store.findById", query = "SELECT s FROM Store s WHERE s.id = :id"),
    @NamedQuery(name = "Store.findByMedicineId", query = "SELECT s FROM Store s WHERE s.medicineId = :medicineId"),
    @NamedQuery(name = "Store.findByUnitPrice", query = "SELECT s FROM Store s WHERE s.unitPrice = :unitPrice"),
    @NamedQuery(name = "Store.findByUnits", query = "SELECT s FROM Store s WHERE s.units = :units"),
    @NamedQuery(name = "Store.findBySold", query = "SELECT s FROM Store s WHERE s.sold = :sold")})
public class Store implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @NotNull
    @Column(name = "ID")
    private Integer id;
    @Basic(optional = false)
    @NotNull
    @Column(name = "MEDICINE_ID")
    private int medicineId;
    @Basic(optional = false)
    @NotNull
    @Column(name = "UNIT_PRICE")
    private double unitPrice;
    @Basic(optional = false)
    @NotNull
    @Column(name = "UNITS")
    private int units;
    @Basic(optional = false)
    @NotNull
    @Column(name = "SOLD")
    private boolean sold;

    public Store() {
    }

    public Store(Integer id) {
        this.id = id;
    }

    public Store(Integer id, int medicineId, double unitPrice, int units, boolean sold) {
        this.id = id;
        this.medicineId = medicineId;
        this.unitPrice = unitPrice;
        this.units = units;
        this.sold = sold;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public int getMedicineId() {
        return medicineId;
    }

    public void setMedicineId(int medicineId) {
        this.medicineId = medicineId;
    }

    public double getUnitPrice() {
        return unitPrice;
    }

    public void setUnitPrice(double unitPrice) {
        this.unitPrice = unitPrice;
    }

    public int getUnits() {
        return units;
    }

    public void setUnits(int units) {
        this.units = units;
    }

    public boolean getSold() {
        return sold;
    }

    public void setSold(boolean sold) {
        this.sold = sold;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Store)) {
            return false;
        }
        Store other = (Store) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "org.faziz.flexigrid.domain.Store[ id=" + id + " ]";
    }
    
}
