/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.faziz.flexigrid.service;

import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.ws.rs.*;
import org.faziz.flexigrid.domain.Customer;
import org.faziz.flexigrid.service.dto.Page;

/**
 *
 * @author faisal
 */
@Stateless
@Path("customers")
public class CustomerFacadeREST extends AbstractFacade<Customer> {

    @PersistenceContext(unitName = "org.faziz_flexigrid_war_1.0-SNAPSHOTPU")
    private EntityManager em;

    public CustomerFacadeREST() {
        super(Customer.class);
    }

    @POST
    @Override
    @Consumes({"application/xml", "application/json"})
    public void create(Customer customer) {
        super.create(customer);
    }

    @PUT
    @Override
    @Consumes({"application/xml", "application/json"})
    public void edit(Customer customer) {
        super.edit(customer);
    }

    @DELETE
    @Path("{id}")
    public void remove(@PathParam("id") Integer id) {
        super.remove(super.find(id));
    }

    @GET
    @Path("{id}")
    @Produces({"application/xml", "application/json"})
    public Customer find(@PathParam("id") Integer id) {
        return super.find(id);
    }
    
//    @GET
//    @Path("{id}")
//    @Produces({"application/xml", "application/json"})
//    public List<Customer> getRequestedPage(@QueryParam("page") Integer page, 
//        @QueryParam("qtype") String qtype, @QueryParam("query") String query,
//        @QueryParam("rp") int rp, @QueryParam("sortname") String sortname, 
//        @QueryParam("sortorder") String sortorder) {
//        return findAll();
//    }

    @GET
    @Override
    @Produces({"application/xml", "application/json"})
    public Page<Customer> findAll() {
        return super.findAll();
    }

    @GET
    @Path("{from}/{to}")
    @Produces({"application/xml", "application/json"})
    public List<Customer> findRange(@PathParam("from") Integer from, @PathParam("to") Integer to) {
        return super.findRange(new int[]{from, to});
    }

    @GET
    @Path("count")
    @Produces("text/plain")
    public String countREST() {
        return String.valueOf(super.count());
    }

    @java.lang.Override
    protected EntityManager getEntityManager() {
        return em;
    }
}
